;---------------------------------------------------------------------
; stringlib_def.i
;
; assembler defines for string.library
;
; History:
;    89-04-29  created
;---------------------------------------------------------------------

;--library function offsets from base structure
	LIBINIT
	LIBDEF		LTOX
	LIBDEF		XTOL
	LIBDEF		STRREQ
	LIBDEF		CENTER
	LIBDEF		LENGTHOF
	LIBDEF		COPYSTR
	LIBDEF		CTOP
	LIBDEF		BTOCSTR
	LIBDEF		MIDSTR
	LIBDEF		LEFTSTR
	LIBDEF		RIGHTSTR
	LIBDEF		INSERTSTR
	LIBDEF		DELSTR

;--stringlib data area structure - this is appended to Library structure
;--at offset LIB_SIZE
	STRUCTURE	StringLibrary,LIB_SIZE
	ULONG		stl_SysLib
	ULONG		stl_DosLib
	ULONG		stl_IntLib
	ULONG		stl_SegList
	UBYTE		stl_Flags
	UBYTE		stl_Pad
	LABEL		StringLib_Sizeof

	STRUCTURE	StrRequester,0
	WORD		sr_LeftEdge
	WORD		sr_TopEdge
	LONG		sr_MaxOutWidth
	APTR		sr_Prompt
	APTR		sr_OutBuff
	APTR         	sr_Screen
	LABEL		StrRequester_Sizeof

;--name of my library
STRINGLIBNAME	MACRO
		dc.b	'string.library',0
		ENDM
